/* G-CTB GNU Contabilidad
 * Copyright (C) 2001 Branly Abendano, EPN Ingenieria Sistemas  
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public  
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This software is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of   
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this software; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#include "TipoCtaContable.h"

Gda_Recordset *GetListadoTotalDeTiposCtasContables (void)
{
   Gda_Recordset *grs;
   gint rc;
                                        
  	grs = gda_recordset_new();
  	gda_recordset_set_connection(GDA_RECORDSET(grs), cnc);
  	rc = gda_recordset_open_txt(GDA_RECORDSET(grs),
			      "SELECT CD_TIPO_CTA_CONTABLE, NM_TIPO_CTA_CONTABLE, DESCRIPCION FROM TIPO_CTA_CONTABLE ORDER BY CD_TIPO_CTA_CONTABLE",
                              GDA_OPEN_STATIC,
                              GDA_LOCK_PESSIMISTIC,
                              0);
  	if (rc < 0) {
		g_print("\nNo se pudo ejecutar la consulta.\n");
    		gtk_main_quit();
  	}

  	return GDA_RECORDSET(grs); 
}

Gda_Recordset *GetListadoNombresTiposCtasContables (void)
{
   Gda_Recordset *grs;
   gint rc;
                                        
  	grs = gda_recordset_new();
  	gda_recordset_set_connection(GDA_RECORDSET(grs), cnc);
  	rc = gda_recordset_open_txt(GDA_RECORDSET(grs),
			      "SELECT NM_TIPO_CTA_CONTABLE FROM TIPO_CTA_CONTABLE ORDER BY CD_TIPO_CTA_CONTABLE",
                              GDA_OPEN_STATIC,
                              GDA_LOCK_PESSIMISTIC,
                              0);
  	if (rc < 0) {
		g_print("\nNo se pudo ejecutar la consulta.\n");
    		gtk_main_quit();
  	}

  	return GDA_RECORDSET(grs); 
}

gint InsertNuevoTipoCtaContable (gchar *NombreTipoCtaContable, gchar *DescripcionTipoCtaContable)
{
   gchar *ConsultaInicial = "INSERT INTO TIPO_CTA_CONTABLE(NM_TIPO_CTA_CONTABLE,DESCRIPCION) VALUES('";
   gchar *ConsultaTmp = NULL;
        
   Gda_Recordset *grs;
   Gda_Command* cmd;
   gulong* n=0;
        
        ConsultaTmp = g_strconcat(ConsultaInicial,NombreTipoCtaContable,NULL);
        ConsultaTmp = g_strconcat(ConsultaTmp,"','",NULL);
        ConsultaTmp = g_strconcat(ConsultaTmp,DescripcionTipoCtaContable,NULL);
        ConsultaTmp = g_strconcat(ConsultaTmp,"')",NULL);
   
        grs = gda_recordset_new();
        gda_recordset_set_connection(GDA_RECORDSET(grs), cnc);

        cmd = gda_command_new();
        gda_command_set_connection (cmd,cnc);
        gda_command_set_text(cmd,ConsultaTmp);
   
        gda_connection_begin_transaction (cnc);
        grs = gda_command_execute(cmd,&n,0);
        gda_connection_commit_transaction (cnc);

	return 0;
}

gint DeleteTipoCtaContable (gchar *CodigoTipoCtaContable)
{
   gulong* n=0;
   gchar *ConsultaInicial = "DELETE FROM TIPO_CTA_CONTABLE WHERE CD_TIPO_CTA_CONTABLE=";
   gchar *ConsultaTmp = NULL;

   Gda_Recordset *grs;
   Gda_Command* cmd;
 
        ConsultaTmp = g_strconcat(ConsultaInicial,CodigoTipoCtaContable,NULL);
 
        grs = gda_recordset_new();
        gda_recordset_set_connection(GDA_RECORDSET(grs), cnc);
 
        cmd = gda_command_new();
        gda_command_set_connection (cmd,cnc);
        gda_command_set_text(cmd,ConsultaTmp);
   
        gda_connection_begin_transaction (cnc);
        grs = gda_command_execute(cmd,&n,0);
        gda_connection_commit_transaction (cnc);
   
	return 0;

}
